


        A graphical program to display plots and images.

         By Vincent Croquette and Nicolas Garnier, Nov, 2003.

        See the AUTHORS file for a
           complete list of contributors.



#include <std_disclaimer.h>

   "We do not accept responsibility for any effects, adverse or otherwise, 
    that this code may have on you, your computer, your sanity, your dog, 
    and anything else that you can think of. Use it at your own risk."



====================================
============ Using Xvin ============
====================================

Xvin is a general program to display plots and images. It is oriented to
present physical results. The goal is to provide a relatively simple
graphical tools allowing to handle scientific data and to perform common
numerical treatements. The emphasis is made in its ability to manipulate
large numbers of points (several millions) and to be has fast as possible.
The interface is on the other hand rather simplistic.



Xvin is also made to be easily expandable using plug-ins written in C and
loaded dynamically. Whithin Xvin you can automatically generate a project
directory MyProject holding a set of files: MyProject.h, MyProject.c the 
associated makefile which serves as a canvas to write simple applications
adding a new function attached to a menu button. 


int xvin_main(int argc, char** argv);
   Start xvin passing the command line arguments




typedef struct plot_label p_l;

    int type;           type of label : in absolute or user defined coordinate
    float xla, yla;     the x, y position of the label 
    char *text;         the string containing the text of the label
    struct box *b;      its internal representation

    Type may be one of those

    ABS_COORD           
    USR_COORD           
    VERT_LABEL_USR      
    VERT_LABEL_ABS      
    WHITE_LABEL         
    OVER_WHITE          






typedef struct data_set d_s

    int nx, ny, type;          the number of x and y data 
    int mx, my;                the size allocated for x and y     
    float *xd, *yd;            pointers to the x and y data 
    float *xe, *ye;               the x and y error on data 
    char *symb;                the symbol to plot describe as a string
    int m;                     a flag defining the line style 
    int color;                 the drawing color 
    unsigned long time;        the time and date of creation 
    char *source;              a string defining from where the data comes from
    char *history;             a string defining the previous treatement
    char *treatement;          a string defining the last treatement
    char **special;            a pointer to an array of user specific string
    int n_special, m_special;  the number of them and the size of the array
    struct plot_label **lab;   labelling in the plot attached to ds 
    int n_lab, m_lab;          the last and size    
    struct hook use;           a structure allowing to attach extra data
    int need_to_refresh;
    double record_duration;    duration of data acquisition in micro seconds */
    long long record_start;    start of duration of data */




#define get_pl_x(pl)
   A macro grabbing the X coordinate of a plot label

#define set_pl_x(pl,x)
   A macro setting the X coordinate of a plot label

#define get_pl_y(pl)
   A macro grabbing the Y coordinate of a plot label

#define set_pl_y(pl,y)
   A macro setting the y coordinate of a plot label

#define get_pl_text(pl)
   A macro grabbing the text string of a plot label

p_l* create_plot_label(int type, float x, float y, char *format,...);
   Create a plot label by setting variables and allocating the text string using
   a printf format.

      pl = create_plot_label (USR_COORD, 1, 2, "Nice point at %g",val);


p_l* duplicate_plot_label(p_l *pls);
   Duplicate a plot label 

int free_plot_label(p_l *pl);
   Free both the text string and the structure.
       

d_s* build_data_set(int nx, int ny);
    Create the data set structure and allocate the x and y array to the 
    corresponding size.

d_s* build_adjust_data_set(d_s *ds, int nx, int ny);
    If the data set passed is null this function call build_data_set, otherwise
    it allow to reallocate the arrays to the new size.
    
d_s* duplicate_data_set(d_s *src, d_s *dest);
    Copy a data set and all its features
    
int free_data_set(d_s *ds);
    Tree everything allocated in the structue as well as the structure itself.
    If the function ds_free_use has been defined, this function is called.
    
int add_new_point_to_ds(d_s *ds, float x, float y);
    This function add a new point to a data set as its last points, it 
    automatically reallocate data arrays if needed.
    

#define    get_ds_nx(ds)        
    macro giving the number of points in x
    
#define    get_ds_ny(ds)        
    macro giving the number of points in y    
    
#define set_ds_x_point(ds,x,i)    
    macro setting the x value of the point of index i, no check is made on 
    array boundary.  

#define set_ds_y_point(ds,y,i)     
    macro setting the y value of the point of index i, no check is made on 
    array boundary.  
  
#define set_ds_point(ds,x,y,i)    
    macro setting both the x and y value of the point of index i, no check 
    is made on array boundary   

#define get_ds_x_point(ds,i)    
    macro getting the x value of the point of index i, no check is made on 
    array boundary 

#define get_ds_y_point(ds,i)    
    macro getting the y value of the point of index i, no check is made on 
    array boundary 

float* get_ds_x_ptr(d_s *ds);
    Macro use to obtain the pointer to the float array of X coordinate.

float* get_ds_y_ptr(d_s *ds);
    Macro use to obtain the pointer to the float array of Y coordinate.
                        
int set_ds_dash_line(d_s *ds);
    This function specify the data set properties.

int set_ds_dot_line(d_s *ds);
    This function specify the data set properties.
    
int set_ds_plain_line(d_s *ds);
    This function specify the data set properties.
    
int set_ds_line_color(d_s *ds, int color);
    This function specify the color of the data set.
        
#define get_ds_line_color(ds)    
    This macro retrieve the color of the data set.

int set_ds_point_symbol(d_s *ds, char *symb);
    This function specify the symbol to be drawn at each point.

      set_ds_point_symbol(ds, "\\pt6\\gamma");

    place the greek symbol in six point size at each plotted point.
    
#define get_ds_point_symbol(ds)    
    Grap the pointer to the string describing the plot symbol.
    
int inherit_from_ds_to_ds(d_s *dest, d_s *src);
    Use to transfert all the property of one data set to a second one which
    correspond to a treatement done to the first one.
    
int set_ds_source(d_s *ds, char *format, ...);
    Printf style function allowing to specify the source of the data set. The 
    string is automatically allocated to the required size.

      set_ds_source(ds, "Original data set having number %d", n_data);
    

#define get_ds_source(ds)    ((ds) == NULL) ? NULL : (ds)->source
    Grab the pointer to the string describing the source of the data set.
    
int set_ds_history (d_s *ds, char *format, ...);
    Printf style function allowing to specify the history of the data set. The 
    string is automatically allocated to the required size.
    
#define get_ds_history(ds)    ((ds) == NULL) ? NULL : (ds)->history
    Grap the pointer to the string describing the history of the data set.

int set_ds_treatement (d_s *ds, char *format, ...);
    Printf style function allowing to specify the treatement of the data set. The 
    string is automatically allocated to the required size.
    
#define get_ds_treatement(ds)    ((ds) == NULL) ? NULL : (ds)->treatement
    Grap the pointer to the string describing the treatement of the data set.

int push_plot_label_in_ds (d_s *ds, float tx, float ty, char *label, int type);
    Create and attach a plot label to a data set. The parameter label is
    duplicated.    
    
int set_ds_plot_label(d_s *ds, float tx, float ty, int type, char *format, ...);
    Create and attach a plot label to a data set. The text of the label may be 
    created using a printf format.

int remove_plot_label_from_ds (d_s *ds, p_l *pl);
    Remove a specific label and free the plot label.

d_s* alloc_data_set_x_error(d_s *ds);
    Allocated the array necessaray to hold the error along x. The number of
allocated float correspond to the present number of points of the data set.

d_s* alloc_data_set_y_error(d_s *ds);
    Allocated the array necessaray to hold the error along y. The number of
allocated float correspond to the present number of points of the data set.

int free_data_set_x_error(d_s *ds);
    Free the error associated array in x. 
    
int free_data_set_y_error(d_s *ds);
    Free the error associated array in y. 

int add_to_data_set(d_s *ds, int type, void *stuff);
    General function used to attach a new thing to a data set. This may be a 
    special feature or a plot label.
    
int remove_from_data_set (d_s *ds, int type, void *stuff);
    General function used to detach and free something to a data set. This 
    may be a special feature or a plot label.
    
int remove_point_from_data_set(d_s *src, int n_one);
    Remove a point from the data set and rearrange points.
    

int ds_special_2_use (d_s *ds);

int ds_use_2_special (d_s *ds);

int ds_free_use(d_s *ds);

int ds_duplicate_use (d_s *dsd, d_s *dss);

int set_ds_starting_time (d_s *ds);
     Set the time stamp to the present time and initiate the duration to 0      


int set_ds_ending_time (d_s *ds);
     Set the time duration of the data set acquisition  

===============================
============ Units ============
===============================

Data in plots or images have one or several units which are define by a
structure specifying the type of unit and the affine transform which turn
the data numbers in physicals measure. A typical situation is for instance
to the data coming from an AD converter which are integer values ranging from
0 to 65535 for



typedef struct unit_set un_s;

    int     type, sub_type, axis;      identifier 
    float   ax, dx;                    the offset and increment 
    char    decade;                    the decade value
    char    mode;                      log or a^2 
    char    *name;                     the text of it 


#define    get_unit_type(un)        
    Macro allowing to acces the unit set type;

#define    set_unit_type(un, type)    
    Macro defining the unit set type which may be one of the value below;
        


         IS_VOLT            
         IS_AMPERE        
         IS_METER        
         IS_NEWTON        
         IS_SECOND        
         IS_GRAMME        
         IS_GAUSS        
         IS_OHM            
         IS_RAW_U                 



#define    get_unit_sub_type(un)        
    Macro allowing to acces the unit set subtype;

#define    set_unit_sub_type(un,stype)    
    Macro defining the unit set subtype;


#define    get_unit_axis(un)        
    Macro allowing to acces the unit set axis;

#define    set_unit_axis(un,axis)        
    Macro defining the unit set axis which may be one of the value below;


        IS_X_UNIT_SET        
        IS_Y_UNIT_SET        
        IS_Z_UNIT_SET        
        IS_T_UNIT_SET        
        IS_UNIT_SET        


#define    set_unit_decade(un,dec)    
    Macro allowing to acces the unit set decade;
    
#define    get_unit_decade(un)    
    Macro defining the unit set decade which may be one of the value below;


         IS_TERRA          12
         IS_GIGA            9
         IS_MEGA            6
         IS_KILO            3
         IS_MILLI          -3
         IS_MICRO          -6
         IS_NANO           -9
         IS_PICO          -12
         IS_FEMTO         -15



#define    set_unit_offset(un,off)    
    Macro defining the unit set offset of the affine transformation.
    
#define    get_unit_offset(un)        
    Macro allowing to acces the unit set offset of the affine transformation.

#define    set_unit_increment(un,inc)    
    Macro allowing to acces the unit set increment of the affine transformation.

#define    get_unit_increment(un)        
    Macro defining the unit set increment of the affine transformation.

#define    set_unit_mode(un,mod)    
    Macro defining the unit set mode.

#define    get_unit_mode(un)    
    Macro allowing to acces the unit set mode.

#define    set_unit_name(un,name)    
    Macro defining the unit set name, name is a string that is attached to the 
 structure.

#define    get_unit_name(un)    
    Macro allowing to acces the unit set name.


un_s* build_unit_set (int t, float ax, float dx, char d, char m, char *name);
    Create the unitset structure in one step, the name is duplicated.

    un = build_unit_set(IS_VOLT, -5, (float)10/16384, 0, 0, "V");

    This create a unit set which will convert from a 16 bits CAD to volts. 

int free_unit_set(un_s *uns);
    Free the unit set.

un_s* duplicate_unit_set(un_s *dest, un_s *src);
    Copy one unit set in dest if dest is different from NULL, otherwise
 create a copy of src.

    


char* generate_units (int type, int decade);
    Construct a string describing the actual unit.

    char *name;
    name = generate_units (IS_VOLTS, IS_MICRO);
    
    Will produce a string containing "\\mu V" (micro Volts).
    

int unit_to_type (char *unit, int *type, int *decade);
    Just do the opposite: 
 
    int type, decade;
    unit_to_type ("\\mu V",&type, &decade);
    
    Will produce place IS_VOLTS in type and IS_MICRO in decade.

int change_decade (un_s *un, int dec);
    Allow to switch from micro to nano for instance. The affine transformation
 increment and the unit name is change accordingly.
    
int compare_units (un_s *a, un_s *b);
    Compare two unit sets and return 0 if they correspond to the same unit, 
 otherwise return 1. This fuction handle correctly the fact that the unit 
 sets are in different decade mode (you can compare microvolts and kilovolts) 

int modify_un_decade (void);
    Menu function allowing to modify the decade.

int modify_units (void);
    Menu function allowing to modify the normal unit set of an image or a plot.

int modify_units_prime (void);
    Menu function allowing to modify the unit set of a plot associated with the top and right axis.

int add_new_units (void);
    Menu function allowing to add a new unit set.
    
int switch_un_ty (void);
    Menu function allowing to switch type.

int switch_un_dec (void);
    Menu function allowing to switch decade.

int    get_afine_param_from_unit (un_s *un, float *ax, float *dx);
    This function return the affine transform parameters corresponding to a 
 unit set in  the decade = 0 mode so that you can easily compare units.

int    set_afine_param_for_unit_with_decade (un_s *un, float ax, float dx, int decade);
    This function is used to set the affine transform parameters of a unit set 
 with the specify decade. ax and dx are give in zero decade mode the unitset is
 transform to the specify deacde.

    set_afine_param_for_unit_with_decade (un, -5, (float)10/16384, IS_MILLI);
    
    set the unit set for the AD converter in the -5000 mV to + 5000 mV range.  


===============================
============ Plots ============
===============================



the plot structure is as follow:

typedef struct one_plot O_p;

    int type;
    char *filename, *dir;                          holding the file info
    char *title, *x_title, *y_title;               title texts
    char *x_prime_title, *y_prime_title;    
    char *x_prefix, *y_prefix, *t_prefix;
    char *x_unit, *y_unit, *t_unit;        
    float width, height, right, up;                size of plot
    float ax, dx, ay, dy, at, dt;                  affine transformation 
    int iopt, iopt2;    
    float tick_len, tick_len_x, tick_len_y;
    float x_lo, x_hi, y_lo, y_hi;                  the plot boundary
    struct data_set **dat;                         the real data 
    int n_dat, m_dat;                              the number of data set
    int cur_dat;                                   the current one 
    struct plot_label **lab;                       labelling in the plot 
    int n_lab, m_lab;                              the last and size
    un_s    **xu;                                  unit set 
    int n_xu, m_xu, c_xu,  c_xu_p;
    un_s    **yu;                                  y unit set 
    int n_yu, m_yu, c_yu,  c_yu_p;    
    un_s    **tu;                                  t unit set (index) 
    int n_tu, m_tu, c_tu,  c_tu_p;    
    struct box    bplt;                            the associated box plot 
    int    need_to_refresh;




O_p* create_one_plot (int nx, int ny, int data_type);
    Create a plot holding one data set of size nx, ny.

int free_one_plot (O_p *op);
    free a plot and all its associated info
    
int init_one_plot (O_p *op);
    Initalize the structure member.
    
O_p* duplicate_plot_data (O_p *src, O_p *dest);
    Duplicate a data set, if dest is set to NULL then it is created.

d_s* create_and_attach_one_ds (O_p *op,int nx, int ny, int data_type);
    Create a new data set and attach it to the plot structure 

int add_one_plot_data (O_p *op, int type, void *stuff);
    See below

int add_data_to_one_plot (O_p *op, int type, void *stuff);
    Attach a data set, a label, a unit set, a special to the plot structure.
    You beter use the more specific functions.    
    
int remove_data_from_one_plot (O_p *op, int type, void *stuff);
    Detach anf free some plot data (data set, labels, unit set special).
    You beter use the more specific functions.

int remove_one_plot_data (O_p *op, int type, void *stuff);
    See above.

int do_it_one_plot_op (O_p *o_p);
    Convert data to graphical information.

int swap_x_y_in_plot (O_p *op);
    Swap the x and y axis.

int set_op_x_unit_set (O_p *op, int n);
    Select the unit set to be used now.

int set_op_y_unit_set (O_p *op, int n);
    Select the unit set to be used now.

int set_op_t_unit_set (O_p *op, int n);
    Select the unit set to be used now for index.

int find_x_limits (O_p *op);
    Find the x limits automatically and place the min and the max in x_lo and x_hi

int find_y_limits (O_p *op);
    Find the y limits automatically and place the min and the max in y_lo and y_hi

int set_plot_title (O_p *op, char *format, ...);
    Add a title to the plot using a printf format.

int set_plot_x_title (O_p *op, char *format, ...);
    Add a title in X to the plot using a printf format.

int set_plot_y_title (O_p *op, char *format, ...);
    Add a title in Y to the plot using a printf format.

int set_plot_x_prime_title (O_p *op, char *format, ...);
    Add a title along top X axis to the plot using a printf format.

int set_plot_y_prime_title (O_p *op, char *format, ...);
    Add a title along right Y axis to the plot using a printf format.

int set_plot_y_log (O_p *op);
    Set plot in log scale in y.

int set_plot_x_log (O_p *op);
    Set plot in log scale in x.

int is_plot_y_log (O_p *op);
    Determine if plot is in log scale in y.

int is_plot_x_log (O_p *op);
    Determine if plot is in log scale in x.

int set_plot_y_lin (O_p *op);
    Set plot in linear scale in y.
    
int set_plot_x_lin (O_p *op);
    Set plot in linear scale in x

int set_plot_x_fixed_range (O_p *op);
    Set plot in fixed scale in x.

int set_plot_x_auto_range (O_p *op);
    Set plot in auto scale mode in x.

int is_plot_x_auto_range (O_p *op);
    Determine if plot is in fixed range mode in X.
    
int set_plot_y_fixed_range (O_p *op);
    Set plot in fixed scale in y.

int set_plot_y_auto_range (O_p *op);
    Set plot in auto scale mode in y.

int is_plot_y_auto_range (O_p *op);
    Determine if plot is in fixed range mode in Y.

int set_op_filename (O_p *op, const char *format, ...);
    Duplicate and attach filename to this plot using a printf format. 

        set_op_filename(op, "histogram%04d.gr", n_histo++);
    

int set_op_path (O_p *op, const char *format, ...);
    Duplicate and attach a path to this plot using a printf format. 

char* get_op_filename (O_p *op);
    Grab the string pointer to the plot filename.
    
char* get_op_path (O_p *op);
    Grab the string pointer to the plot path.
                
int push_plot_label (O_p *op, float tx, float ty, char *label, int type);
    You should better used set_op_plot_label or set_ds_plot_label

int set_op_plot_label (O_p *op, float tx, float ty, int type, char *format, ...);
    Create and attach a plot label to a plot. The text of the label may be 
    created using a printf format. Plot label attach to a plot are general,
    if you want a label attach to a data set use set_ds_plot_label.
    

        float Ture = 298;
        set_op_plot_label(op, 0.5, 0.5, USR_COORD,"All data have been done at T = %g degrees", Ture);
    

int set_op_width (O_p *op, float width);
    Define the plot width, the default is 1.
    
int set_op_height (O_p *op, float height);
    Define the plot heigh, the default is 1.
    
float get_op_width (O_p *op);
    grab the plot width, the default is 1.
    
float get_op_height (O_p *op);
    grab the plot heigh, the default is 1.
    
d_s* get_op_cur_ds (O_p *op);
    grab the current data set of the plot.

int create_attach_select_x_un_to_op (O_p *op, int type, float ax, float dx, char decade, char mode, char *name);
    Create and attach a unit set affecting the plot x axis.

int create_attach_select_y_un_to_op (O_p *op, int type, float ax, float dx, char decade, char mode, char *name);
    Create and attach a unit set affecting the plot y axis.

int create_attach_select_t_un_to_op (O_p *op, int type, float ax, float dx, char decade, char mode, char *name);
    Create and attach a unit set affecting the plot t axis.

int add_ds_to_op (O_p *op, d_s *ds);
    Attach an already created data set to a plot.

int add_plot_label_to_op (O_p *op, p_l *pl);
    Attach an already created plot label. Usually you will use set_op_plot_label 
    or set_ds_plot_label instead.

int add_x_unit_set_to_op (O_p *op, un_s *un);
    Attach an already created unit set to the x plot axis. Usually you will use
    create_attach_select_x_un_to_op which create and attach the unit set.

int add_y_unit_set_to_op (O_p *op, un_s *un);
    Attach an already created unit set to the y plot axis. Usually you will use
    create_attach_select_y_un_to_op which create and attach the unit set.

int add_t_unit_set_to_op (O_p *op, un_s *un);
    Attach an already created unit set to the t plot axis. Usually you will use
    create_attach_select_t_un_to_op which create and attach the unit set.
    
int remove_ds_from_op (O_p *op, d_s *ds);
    Remove a data set and completely free the memory allocated by data set arrays.

int remove_ds_n_from_op(O_p *op, int n);    
    Remove the nth data set and completely free the memory allocated by data set arrays.            

int remove_plot_label_from_op (O_p *op, p_l *pl);
    Remove the specified plot label and free all the associated memory.            

int remove_x_unit_set_from_op (O_p *op, un_s *un);
    Remove the specified unit set and free all the associated memory.            
    
int remove_y_unit_set_from_op (O_p *op, un_s *un);
    Remove the specified unit set and free all the associated memory.    

d_s* find_source_specific_ds_in_op (O_p *op, char *source);
    Scan all the data set of this plot and return the one having the source
    matching the define pattern.


d_s* find_treatement_specific_ds_in_op (O_p *op, char *treatement);
    Scan all the data set of this plot and return the one having the treatement
    matching the define pattern.

int affine_transform_all_plot_unitset (O_p *op, int axis, float offset, float multiplier);
    Scan all the unit set of the specified axis and apply an affine transform 
    to all of them.

        affine_transform_all_plot_unitset(op, IS_X_UNIT_SET, 1, 2.5);
    

int switch_plot_data_set (O_p *op, int n_dat);
    Define n_dat data set as the current one.


int uns_op_2_op_by_type (O_p *src, int src_axis, O_p *dest, int dest_axis);
    Duplicate all the unit set of the plot src corresponding to to the axis 
    src_axis to the destination plot dest and axis dest_axis.

        /* duplicate the x unit set of original data to the y axis of dest */
        uns_op_2_op_by_type(src, IS_X_UNIT_SET, dest, int IS_Y_UNIT_SET);
        

int uns_op_2_op (O_p *dest, O_p *src);
    Duplicate all the unit set of the x and y axis of src to dest.

        uns_op_2_op (dest, src);
        /* is equivalent to */
        uns_op_2_op_by_type(src, IS_X_UNIT_SET, dest, int IS_X_UNIT_SET);
        uns_op_2_op_by_type(src, IS_Y_UNIT_SET, dest, int IS_Y_UNIT_SET);        
        uns_op_2_op_by_type(src, IS_T_UNIT_SET, dest, int IS_T_UNIT_SET);        
        

=====================================
============ Plot region ============
=====================================



the screen representation of plot is a plot region structure it is defined as follow:

typedef struct plot_region pltreg;

{
    dybox       db;         /* boundary of it */
    rec         def;            /* def of position */    
    struct box  *stack;            /* box translation of plot */
    struct box  *plt;            /* box of plot */
    int         x_off, y_off;        /* its bottom left corner */
    int         s_nx, s_ny;        /* the plot size on screen */
    int         screen_scale, max_scale, min_scale, auto_scale;    
        /* ratio from box to screen */
    float       mag_step;        /* magnification fac.*/
    int         x0, y0;            /* x & y offset to box */
    dybox       *l_db;            /* list of active box */
    int         n_db, m_db;        /* number, alloced */
    O_p         *one_p;            /* active = o_p[cur_op] */
    O_p         **o_p;            /* the series of plot */
    int         n_op, m_op;        /* the number of plot */
    int         cur_op;            /* the current one */
    struct box  all;            /* the combination of plot */
    int         display_mode;    /* normal or all plots */
    int         *c_op;            /* an array for plot ordering */        
    char        *filename;        /* the name of the project file */    
    char        *path;            /* the name of the project directory */        
    int          mark_v,mark_h;    /* the positions of markers */
    struct hook  use;            /* allow to attach more data */    





# define     IS_ONE_PLOT        1024
# define    ALL_PLOTS    1025

# define    MAX_SCALE    8192
# define    MIN_SCALE    4096
# define    DEC_SCALE    2048
# define    INC_SCALE    1024
# define    AUTO_SCALE    512


pltreg* build_plot_region (int x0, int y0, int w, int h);

O_p* create_and_attach_one_plot (pltreg *p,int x,int y,int type);

int add_data (pltreg *pr, int type, void *stuff);

int add_data_to_pltreg (pltreg *pr, int type,void *stuff);

int remove_data (pltreg *pr, int type, void *stuff);

#define remove_data_from_pltreg remove_data


int remove_data_from_pltreg (pltreg *pr, int type, void *stuff);

int free_plot_region (pltreg* pr);

int do_one_plot (pltreg *pr);

int do_it_one_plot (pltreg *pr);


int display_plot_region (pltreg *pr);

int erase_box (void);

int draw_box (int dx, int dy, int scale, int color);

int spit_box_to_ps (pltreg *pr, char *file);

int refresh_plot (pltreg *pr, int n_plot);


int update_just_plot (pltreg *pr);

int update_plot_db (pltreg *pr);

int run_pr_db (char ch);

dybox* next_pr_db (pltreg *pr);


/* pltreg             *find_plot_reg(acreg *ac); */
d_s* find_cur_data_set (pltreg *plt);


int shift_horz (char ch);

int shift_vert (char ch);

int drag_label (char ch);

int change_label (char ch);

int show_peak (char ch);



int x_pltdata_2_pr (pltreg *pr, float x);
    Convert from the current plot coordinate to the screen coordinate in X.
    The data are assume to be in raw mode (without unit), the function handle
    correctly the fact that the plot is in log scale along this axis.



int y_pltdata_2_pr (pltreg *pr, float y);
    Convert from the current plot coordinate to the screen coordinate in Y.
    The data are assume to be in raw mode (without unit), the function handle
    correctly the fact that the plot is in log scale along this axis.
    

float x_pr_2_pltdata (pltreg *pr, int xvp);
    Convert from the screen coordinate in X to the current plot coordinate.
    The data are assume to be in physical mode (with unit), the function handle
    correctly the fact that the plot is in log scale along this axis.
    The screen units are not absolute but relative to the plot region origin. 

float y_pr_2_pltdata (pltreg *pr, int yvp);
    Convert from the screen coordinate in Y to the current plot coordinate.
    The data are assume to be in physical mode (with unit), the function handle
    correctly the fact that the plot is in log scale along this axis.
    The screen units are not absolute but relative to the plot region origin.     

float x_pr_2_pltdata_raw (pltreg *pr, int xvp);
    Convert from the screen coordinate in X to the current plot coordinate.
    The data are assume to be in raw mode (without unit), the function handle
    correctly the fact that the plot is in log scale along this axis.
    The screen units are not absolute but relative to the plot region origin.     

float y_pr_2_pltdata_raw (pltreg *pr, int yvp);
    Convert from the screen coordinate in Y to the current plot coordinate.
    The data are assume to be in raw mode (without unit), the function handle
    correctly the fact that the plot is in log scale along this axis.
    The screen units are not absolute but relative to the plot region origin. 

dybox* make_box_active (pltreg *pr, int type, int (*action)(char), int mode);



/* local functions */
int find_box_scale (struct box *bo, dybox *db);


float interp (float p,float fp,float f0,float f1,float f2);

int set_plt_x_unit_set (pltreg *pr, int n);

int set_plt_y_unit_set (pltreg *pr, int n);



int prepare_all_plots (pltreg *pr, int n_col);

int plots_in_three_columns (struct box *bo);

int plots_in_two_columns (struct box *bo);

int plots_in_one_column (struct box *bo);


int fft_fil_inr_outr (float *x, int nx, int w_flag, int f, int w);

int fft_fil_inr_outc (float *x, int nx, int w_flag, int f, int w);

int fft_fil_inc_outc (float *x, int nx, int w_flag, int f, int w);

int least_square_fit_on_ds (char ch);

int remove_plot(char ch);

int load_plt_file_in_pltreg (pltreg *pr, char *file, char *path);

pltreg* find_pr_in_current_dialog (DIALOG *di);

int set_plt_x_unit_set (pltreg *pr, int n);

int set_plt_y_unit_set (pltreg *pr, int n);


d_s* find_source_specific_ds_in_pr (pltreg *pr, char *source);


int find_op_nb_of_source_specific_ds_in_pr (pltreg *pr, char *source);

int find_op_nb_of_treatement_specific_ds_in_pr (pltreg *pr, char *treatement);


pltreg* load_cgr_file_in_pltreg (pltreg *pr, char *file_path, char *file);

pltreg* load_cgrfile_in_pltreg (pltreg *pr, char *fullfile);


======================================
============ Image region ============
======================================



the screen representation of images is an image region structure it is defined as follow:


typedef struct image_region imreg                    /* view of an image */

{
        dybox db;                               /* boundary of it */
        rec def;                                /* def of position */   
        struct box stack, stack2;               /* box translation of plot */
        struct box *plt;                        /* box of plot */
        int x_off, y_off;                       /* the image bot. l. corner */
        int s_nx, s_ny;                         /* the image size on screen */
        int screen_scale, max_scale, min_scale; /* ratio from box to screen */
        float mag_step;                         /* magnification fac.*/
        int x0, y0;                             /* x & y offset to box */
        dybox *l_db;                            /* list of active box */
        int n_db, m_db;                         /* number, alloced */
        O_i *one_i;                             /* the im def */
        O_i **o_i;                              /* the series of image */
        int n_oi, m_oi;                         /* the number of image */
        int cur_oi;                             /* the current one */
        int                     mark_v,mark_h;  /* the positions of markers */  
} 



An image region is a screen widget which goal is to display image data. This structure
may contains several images, in normal mode one image is displayed at a time.
Ne number of image in image region is given by n_oi, while the curent one is given
by c_oi. The real image data is contains in the following structure : 

typedef struct one_image O_i

{
        int type;
        char *filename, *dir, *title;   /* The strings defining the titles */
        char *x_title, *y_title, *x_prime_title, *y_prime_title;        
        char *x_prefix, *y_prefix, *x_unit, *y_unit;            
        float width, height, right, up;
        int iopt, iopt2;        
        float tick_len;
        float x_lo, x_hi, y_lo, y_hi;
        float z_black, z_white;         /* grey-scale def */
        float z_min, z_max;             /* grey-scale limit */  
        float ax, dx;                   /* conversion factor and offset */
        float ay, dy;                   /* between pixels and user dim */
        float az, dz;                   /* between pixels and user dim */
        float at, dt;                   /* between frame and time */
        struct image_data im;
        struct plot_label **lab;        /* labelling in the plot */
        int n_lab, m_lab;
        O_p **o_p;                      /* the series of plot */
        int n_op, m_op;                 /* the number of plot */
        int cur_op;                     /* the current one */
        un_s    **xu;                   /* x unit set */
        int n_xu, m_xu, c_xu;
        un_s    **yu;                   /* y unit set */
        int n_yu, m_yu, c_yu;   
        un_s    **zu;                   /* z unit set */
        int n_zu, m_zu, c_zu;   
        un_s    **tu;                   /* t unit set (for movies) */
        int n_tu, m_tu, c_tu;           
        struct hook bmp;                        /* use to attach a BITMAP */    
        int need_to_refresh;
} 


This data structure describes all the attributes of the image, its labels, associated
plots appearing over the image and the units structures associated with x, y, z and t.
An image may in fact be a movie, thus t axis refers to time. This structure pocesses
a serie of pointers allowing to handle the real pixel data. Xvin support a variety of
image data type more specifically designed for scientific usage. The memory associated to
each image is allocated in one memory chunk. A void pointer to each image is accessible
through mem[i] where i is the image number. This number must be smaller than n_f and 
greater or equal to 0. If the image just contains a single image only mem[0] is defined.
More specific data handling is provided to access each line of the image : for a given
frame of a movie, the pixel element is an array of pointer to the structure "pix" 
which allow to handle the different image type, pixel[i] is the pointer to line
i. Xvin display image have line 0 at the bottom ant line ny-1 at the top. However,
the location of these line in memory may be different.




O_i* create_one_image (int nx, int ny, int data_type);
        This function create the O_i structure and allocate memory for one image.

O_i* create_one_movie (int nx, int ny, int data_type, int nb_frames);
        This function create the O_i structure and allocate memory for a movie.

int free_one_image (O_i *oi);
        This routine free all memory attached to one image and the image itself.

O_i* duplicate_image (O_i *src, O_i *dest);
        copy one image to another one, if dest is NULL, the image is created.


/* not to be used */
int init_one_image (O_i *oi, int type);
        Internal function initializing the image structure.

int alloc_one_image (O_i *oi, int nx, int ny, int type);
        Internal function allocating the image memory.

int add_one_image (O_i *oi, int type, void *stuff);
int add_to_one_image(O_i *oi, int type, void *stuff);
        general function used to attach more data (labels, plots, unitset ...) to one image

int remove_one_image (O_i *oi, int type, void *stuff);
int remove_from_one_image (O_i *oi,int type, void *stuff);
        general function used to detach data (labels, plots ...) from one image


struct image_data

{
        int data_type, mode;                    /* char, int or float */
        int nx, nxs, nxe;                       /* nb of x pixels */
        int ny ,nys, nye;                       /* nb of y pixels */
        union pix *pixel;                       /* the image data */
        union pix **pxl;                        /* the array for movie */
        void **mem;                             /* the array containing the starting point of memory of each image */
        int n_f, m_f, c_f;                      /* the number of images */
        unsigned char **over;                   /* overwrite plane 1 bit */
        unsigned long time;                     /* date of creation */
        char *source;
        char *history;
        char *treatement;
        char **special;                         /* strings for special infos*/
        int n_special, m_special;       
        struct hook use;                        /* usage of the image */
        unsigned char win_flag;                 /* boundary conditions */
        int movie_on_disk;                      /* specify if in memory or on disk */
        double record_duration;                 /* duration of data acquisition in micro seconds */
        long long record_start;                 /* start of duration of data */

};


The data type may be one of :



# define        IS_CHAR_IMAGE           // unsigned char 8 bits BW
# define        IS_RGB_PICTURE          // unsigned char 8 bits for each color coponents
# define        IS_RGBA_PICTURE         // unsigned char 8 bits for each color coponents + alpha channel
# define        IS_INT_IMAGE            // signed short int 16 bits BW
# define        IS_UINT_IMAGE           // unsigned short int 16 bits BW
# define        IS_LINT_IMAGE           // signed long int 32 bits BW
# define        IS_FLOAT_IMAGE          // float BW
# define        IS_COMPLEX_IMAGE        // complex image of float BW
# define        IS_DOUBLE_IMAGE         // double BW    
# define        IS_COMPLEX_DOUBLE_IMAGE // complex image of double BW





Accessing data is done via an union define here:

union pix    
                             /* data pointer to pixel */
{
        unsigned char *ch;
        short int *in;
        unsigned short int *ui;
        int *li;
        float *fl;
        double *db;
        mcomplex *cp;
        mdcomplex *dcp;
        rgb *rgb;
        rgba *rgba;
};


where elements are defined by the following structures :

typedef struct typedef struct _mcomplex mcomplex;

{ 
        float re, im;
} 


typedef struct _mdcomplex mdcomplex;

{ 
        double dre, dim;
} 


typedef struct _rgb rgb;

{ 
        unsigned char r, g, b;
} 


typedef struct _rgba rgba;

{ 
        unsigned char r, g, b, a;
} 



Of couse, the right union member should be use according to image type : mdcomplex structure
will be valid only if the image is a COMPLEX_DOUBLE_IMAGE. Accesing data in an
image can be done in two ways depending on the fact that the data type is known or not:
If you are creating an image with an unsigned char type then to   
acces the pixel "j" of line "i" of an unsigned char image you should use :

        unsigned char u, *ul;
        O_i *oi;  // a pointer to the image of interest
        // some code defining the image 
        u = oi->im.pixel[i].ch[j]; // this is the value of this pixel
        ul = oi->im.pixel[i].ch; // this is a pointer to the line i
        // or you can do the same thing by using macros 
        u = UCHAR_PIXEL(oi,i,j);
        ul = UCHAR_LINE_PTR(oi,i);
        // or you can do the same thing by using functions  
        u = get_uchar_pixel(oi,i,j);
        ul = uchar_line_ptr(oi,i);
        

This macro method is the most efficient considering speed, the data are directly accessed however
no protection is provided in accessing out of bound data! the functions are slower but saffer.
Of course a set of macros and functions exist for all data type. 


# define        UCHAR_LINE_PTR(oi,line)     (oi)->im.pixel[(line)].ch
# define        SINT_LINE_PTR(oi,line)      (oi)->im.pixel[(line)].in
# define        UINT_LINE_PTR(oi,line)      (oi)->im.pixel[(line)].ui
# define        LINT_LINE_PTR(oi,line)      (oi)->im.pixel[(line)].li
# define        FLT_LINE_PTR(oi,line)       (oi)->im.pixel[(line)].fl
# define        DBL_LINE_PTR(oi,line)       (oi)->im.pixel[(line)].db
# define        RGB_LINE_PTR(oi,line)       (oi)->im.pixel[(line)].rgb
# define        RGBA_LINE_PTR(oi,line)      (oi)->im.pixel[(line)].rgba
# define        CFLT_LINE_PTR(oi,line)      (oi)->im.pixel[(line)].mcomplex
# define        CDBL_LINE_PTR(oi,line)      (oi)->im.pixel[(line)].mdcomplex

# define        UCHAR_PIXEL(oi,line,col)     (oi)->im.pixel[(line)].ch[(col)]
# define        SINT_PIXEL(oi,line,col)      (oi)->im.pixel[(line)].in[(col)]
# define        UINT_PIXEL(oi,line,col)      (oi)->im.pixel[(line)].ui[(col)]
# define        LINT_PIXEL(oi,line,col)      (oi)->im.pixel[(line)].li[(col)]
# define        FLT_PIXEL(oi,line,col)       (oi)->im.pixel[(line)].fl[(col)]
# define        DBL_PIXEL(oi,line,col)       (oi)->im.pixel[(line)].db[(col)]
# define        RGB_PIXEL(oi,line,col)       (oi)->im.pixel[(line)].rgb[(col)]
# define        RGBA_PIXEL(oi,line,col)      (oi)->im.pixel[(line)].rgba[(col)]
# define        CFLT_PIXEL(oi,line,col)      (oi)->im.pixel[(line)].mcomplex[(col)]
# define        CDBL_PIXEL(oi,line,col)      (oi)->im.pixel[(line)].mdcomplex[(col)]
        

unsigned char* uchar_line_ptr(O_i *oi, int line);
short int* sint_line_ptr(O_i *oi, int line);
unsigned short int* uint_line_ptr(O_i *oi, int line);
int* lint_line_ptr(O_i *oi, int line);
float* flt_line_ptr(O_i *oi, int line);
double* dbl_line_ptr(O_i *oi, int line);
rgb* rgb_line_ptr(O_i *oi, int line);
rgba* rgba_line_ptr(O_i *oi, int line);
mcomplex* cflt_line_ptr(O_i *oi, int line);
mdcomplex* cdbl_line_ptr(O_i *oi, int line);


unsigned char get_uchar_pixel(O_i *oi, int line, int col);
short int get_sint_pixel(O_i *oi, int line, int col);
unsigned short int get_uint_pixel(O_i *oi, int line, int col);
int get_lint_pixel(O_i *oi, int line, int col);
float get_flt_pixel(O_i *oi, int line, int col);
double get_dbl_pixel(O_i *oi, int line, int col);
rgb get_rgb_pixel(O_i *oi, int line, int col);
rgba get_rgba_pixel(O_i *oi, int line, int col);
mcomplex get_cflt_pixel(O_i *oi, int line, int col);
mdcomplex get_cdbl_pixel(O_i *oi, int line, int col);

int get_raw_pixel_value(O_i *oi,int ix, int iy, double *val)
This function grabs the pixel at line iy and row ix and place the result
as a double in val whatever the image type is. ix and iy are tested to
be inside the defined image, whenever something is wrong, it shall return
an error code and 0 otherwise. This function handles all images type, this 
means that when the image is of complex type the returned value will be set
according to the visualization mode in use (real, imaginary amplitude ...).
In the same spirit, red, green, blue, alpha or grey level will be given
for rgb type pictures. The code of this function is given as an example. 

{
  double zr, zi;

        if (oi == NULL || ix = oi->im.nx || iy >= oi->im.ny) 
          xvin_error(Wrong_Argument);
        switch (oi->im.data_type)
        {
                case  IS_CHAR_IMAGE:
                        *val = (double)oi->im.pixel[iy].ch[ix];
                break;
                case  IS_RGB_PICTURE:
                  if (oi->im.mode == GREY_LEVEL)
                        *val = ((double)(oi->im.pixel[iy].rgb[ix].r + oi->im.pixel[iy].rgb[ix].g 
                          + oi->im.pixel[iy].rgb[ix].b))/3;
                  else if (oi->im.mode == R_LEVEL)
                        *val = (double)oi->im.pixel[iy].rgb[ix].r;
                  else if (oi->im.mode == G_LEVEL)
                        *val = (double)oi->im.pixel[iy].rgb[ix].g;
                  else if (oi->im.mode == B_LEVEL)
                        *val = (double)oi->im.pixel[iy].rgb[ix].b;
                  else if (oi->im.mode == ALPHA_LEVEL)
                        *val = (double)255;
                  else return 1;
                break;                          
                case  IS_RGBA_PICTURE:
                  if (oi->im.mode == GREY_LEVEL)
                        *val = ((double)(oi->im.pixel[iy].rgba[ix].r + oi->im.pixel[iy].rgba[ix].g 
                          + oi->im.pixel[iy].rgba[ix].b))/3;
                  else if (oi->im.mode == R_LEVEL)
                        *val = (double)oi->im.pixel[iy].rgba[ix].r;
                  else if (oi->im.mode == G_LEVEL)
                        *val = (double)oi->im.pixel[iy].rgba[ix].g;
                  else if (oi->im.mode == B_LEVEL)
                        *val = (double)oi->im.pixel[iy].rgba[ix].b;
                  else if (oi->im.mode == ALPHA_LEVEL)
                        *val = (double)oi->im.pixel[iy].rgba[ix].a;
                  else return 1;
                break;                          
                case  IS_INT_IMAGE:
                        *val = (double)oi->im.pixel[iy].in[ix];
                break;
                case  IS_UINT_IMAGE:
                        *val = (double)oi->im.pixel[iy].ui[ix];
                break;
                case  IS_LINT_IMAGE:
                        *val = (double)oi->im.pixel[iy].li[ix];
                break;                  
                case  IS_FLOAT_IMAGE:
                        *val = (double)oi->im.pixel[iy].fl[ix];
                break;                          
                case  IS_DOUBLE_IMAGE:
                        *val = oi->im.pixel[iy].db[ix];
                break;                          
                case  IS_COMPLEX_IMAGE:
                        zr = oi->im.pixel[iy].cp[ix].re;
                        zi = oi->im.pixel[iy].cp[ix].im;
                        switch (oi->im.mode)
                        {
                                case AMP:
                                *val = sqrt(zr*zr+zi*zi);
                                break;
                                case LOG_AMP:
                                *val = zr*zr+zi*zi;
                                *val = (*val > 0) ? log10(*val) : -40;
                                break;                          
                                case AMP_2:
                                *val = zr*zr+zi*zi;
                                break;
                                case RE:
                                *val = zr;
                                break;
                                case IM:
                                *val = zi;
                                break;
                        };
                break;                          
                case  IS_COMPLEX_DOUBLE_IMAGE:
                        zr = oi->im.pixel[iy].dcp[ix].dre;
                        zi = oi->im.pixel[iy].dcp[ix].dim;
                        switch (oi->im.mode)
                        {
                                case AMP:
                                *val = sqrt(zr*zr+zi*zi);
                                break;
                                case LOG_AMP:
                                *val = zr*zr+zi*zi;
                                *val = (*val > 0) ? log10(*val) : -80;
                                break;                          
                                case AMP_2:
                                *val = zr*zr+zi*zi;
                                break;
                                case RE:
                                *val = zr;
                                break;
                                case IM:
                                *val = zi;
                                break;
                        };
                break;                          
                default: return 1;
        }
        return 0;
}
        

Possible mode values are :

# define        LOG_AMP         8
# define        AMP_2           16
# define        AMP             32
# define        RE              64
# define        IM              128
# define        KX              256
# define        KY              512
# define        PHI             1024
# define        GREY_LEVEL      0
# define        R_LEVEL         2048
# define        G_LEVEL         4096
# define        B_LEVEL         8192
# define        ALPHA_LEVEL     16384


int set_oi_mode(O_i *oi, int mode);
        allow to define the visualization mode of some image type. 

int get_oi_mode (O_i *oi);
        allow to grab the visualization mode of some image type. 


int get_oi_type (O_i *oi);
        allows to grab the data type of an image, while the following macros
allow to test each case.


# define        OI_TYPE_IS_UNSIGNED_CHAR(oi)
# define        OI_TYPE_IS_RGB(oi)
# define        OI_TYPE_IS_RGBA(oi)
# define        OI_TYPE_IS_INT(oi)      
# define        OI_TYPE_IS_UNSIGNED_SHORT_INT(oi)
# define        OI_TYPE_IS_LONG_INT(oi) 
# define        OI_TYPE_IS_FLOAT(oi)    
# define        OI_TYPE_IS_DOUBLE(oi)   
# define        OI_TYPE_IS_COMPLEX(oi)  
# define        OI_TYPE_IS_COMPLEX_DOUBLE(oi)



/* data treatement */

# define        LOW_PASS        32
# define        BAND_PASS       64
# define        HIGH_PASS       128
# define        BRICK_WALL      8192
# define        REAL_MODE       512
# define        COMPLEX_MODE    1024


/* define boundary conditions */

# define        X_PER           1
# define        Y_PER           2
# define        X_NOT_PER       ~X_PER
# define        Y_NOT_PER       ~Y_PER




int set_oi_region_of_interest_in_pixel(O_i *oi, int x0, int y0, int x1, int y1);
        define the region of interest.

int get_oi_region_of_interest_in_pixel(O_i *oi, int *x0, int *y0, int *x1, int *y1);
        grab the region of interest.

int set_oi_source (O_i *oi, char *format, ...);
        define a string of variable size used to specify the image origin. The memory allocation
is done automatically. A sprintf syntax is supported.

char* get_oi_source (O_i *oi);
        grab the string defining the image.

int set_oi_treatement (O_i *oi, char *format, ...);
        define a string of variable size used to specify the image last treatement. The memory allocation
is done automatically. A sprintf syntax is supported.

char* get_oi_treatement (O_i *oi);
        grab the string defining the image treatement.

int set_oi_history (O_i *oi, char *format, ...);
        define a string of variable size used to specify the image succesive treatements. The memory allocation
is done automatically. A sprintf syntax is supported.

char* get_oi_history (O_i *oi);
        grab the string defining the image history.


# define        set_oi_one_special(oi,text)     if ((oi) != NULL) \
                                                add_to_one_image ((oi), \
                                                IS_SPECIAL, (void *)(text))

                                                
int set_oi_periodic_in_x (O_i *oi);
int set_oi_periodic_in_y (O_i *oi);
int set_oi_periodic_in_x_and_y (O_i *oi);
int set_oi_not_periodic_in_x (O_i *oi);
int set_oi_not_periodic_in_y (O_i *oi);
int set_oi_not_periodic (O_i *oi);
        set image periodicity

int get_oi_periodicity_in_x (O_i *oi);
int get_oi_periodicity_in_y (O_i *oi);
        get image periodicity

int set_oi_filename (O_i *oi, char *file);

int set_oi_path (O_i *oi, char *dir);

char* get_oi_filename (O_i *oi);

char* get_oi_path (O_i *oi);


# define        set_oi_title                    set_im_title
# define        set_oi_x_title                  set_im_x_title
# define        set_oi_y_title                  set_im_y_title
# define        set_oi_x_top_title              set_im_x_top_title
# define        set_oi_y_right_title            set_im_y_right_title


int set_im_title (O_i *oi, char *format, ...);
int set_im_x_title (O_i *oi, char *format, ...);
int set_im_y_title (O_i *oi, char *format, ...);
int set_im_x_top_title (O_i *oi, char *format, ...);
int set_im_y_right_title (O_i *oi, char *format, ...);
        define a string of variable size used to specify the image titles. The memory allocation
is done automatically. A sprintf syntax is supported

char* get_oi_title (O_i *oi);
char* get_oi_x_title (O_i *oi);
char* get_oi_y_title (O_i *oi);
char* get_oi_x_top_title (O_i *oi);
char* get_oi_y_right_title (O_i *oi);
        Catches image titles.

int alloc_over_plane (O_i *oi);
int reset_full_over_plane (O_i *oi, int val);
int set_over (O_i *oi, int x, int y);


int fast_interpolate_image_point (O_i *ois,float x,float y,int out_color);
        This fuction interpolates images at fractional pixel position using
a linear interpolation scheme. Interpolate an unsigned char image value at position x and y
in pixel value in a fast manner, less accurate, if the point is outside of the image return 
out_color * 256 otherwise it output le value * 256. This routine only handle unsigned char 
image type.
 

float interpolate_image_point (O_i *ois, float x, float y, float *zr, float *zi);
        This fuction interpolates images at fractional pixel position using
a linear interpolation scheme. The imaginay value will be filled if the image is of complex type
and if zi is not NULL;

int interpolate_RGB_picture_point(O_i *ois, float x, float y, float *zr, float *zg, float *zb, float *za);
        This fuction interpolates RGB and RGBA picture at fractional pixel position using
a linear interpolation scheme. 

int extract_line (O_i *oi, int n_line, float *z);
        Extract one line of an image and place it in the float array z which must have enough
space to accomodate the number of points in one line. The result is rescaled by the z unitset.

int extract_row (O_i *oi, int n_row, float *z);
        Extract one row of an image and place it in the float array z which must have enough
space to accomodate the number of points in one row. The result is rescaled by the z unitset.

int extract_raw_line (O_i *oi, int n_line, float *z);
        Extract one line of an image and place it in the float array z which must have enough
space to accomodate the number of points in one line. The result is not rescaled by the z unitset.

int extract_raw_row (O_i *oi, int n_row, float *z);
        Extract one row of an image and place it in the float array z which must have enough
space to accomodate the number of points in one row. The result is not rescaled by the z unitset.

float* extract_tilted_profile (O_i *oi, float *z, int nz, float x0, float y0, float x1, float y1, int *npts);
float* extract_raw_tilted_profile (O_i *oi, float *z, int nz, float x0, float y0, float x1, float y1, int *npts);
        Extract a profile of an image (oi) starting at point (x0, y0) 
ending at (x1, y1). Both points are included. The profile is
placed in a float array. If z is already allocated (!= NULL),
the routine use this array otherwise it allocate it (it is your
resposability fo free this array once used. The number of points
is calculated using the size of the segment in pixels. If x and y
scaling are different, the y scaling is the reference one. If the
number of points (nz) allocated for the array (z) is smaller than
the required size (*npts), this array is reallocated. The total 
number of points of the profile is returned in (npts).  
On error, npts is set to 0 and the functions return Null.
The raw type does not include the z uniset transformation


int switch_frame (O_i *oi,int n);
        For movies, this function allow to set the current image.

int set_oi_horizontal_extend (O_i *oi, float width);
int set_oi_vertical_extend (O_i *oi, float height);
        Define the width and height of the image a width and height = 1 means 512 
screen pixels (equivalent to screen_scale = PIXEL_0)    


# define        get_oi_horizontal_extend(oi) 
# define        get_oi_vertical_extend(oi) 

        These macros grab the extension of the image.

int     map_pixel_ratio_of_image_and_screen(O_i *oi, float ratiox, float ratioy);
int     what_is_pixel_ratio_of_image_and_screen(O_i *oi, float *ratiox, float *ratioy);
        These functions allow to set or grab the image extension throught the ratio
between the size of the image pixel compared with that of the screen.



# define        set_oi_grid(oi,on_off)
# define        get_oi_grid(oi)                                                 

# define        USER            0
# define        PIXEL           1
# define        NO_NUMBER       2


On the screen, the image is surrouded by axis like a plot. The user may
erase these axis or choose what they represent. They may display the pixel
position or the user units. A mix representation may be done using the top
and bottom axis as well as the right and left axis.

int set_oi_bottom_left_axes (O_i *oi, int mode);
        Choose the mode representation of the bottom and left axis, mode may be USER, PIXEL or
NO_NUMBER

int is_oi_bottom_left_axes_in_pixel (O_i *oi);
        Check for the bottom and left axis state.

int is_oi_bottom_left_axes_numbered (O_i *oi);
        Check for the bottom and left axis state.

int set_oi_top_right_axes (O_i *oi,int pixel_user_nonumber_none);
        Choose the mode representation of the top and right axis, mode may be USER, PIXEL or
NO_NUMBER

int is_oi_top_right_axes_in_pixel (O_i *oi);
        Check for the top and right axis state.

int is_oi_top_right_axes_numbered (O_i *oi);
        Check for the top and right axis state.

int set_oi_plot_axes (O_i *oi,int mode);
        The plot that is diplayed on top of the image may have is X or Y axis varying in the
same manner or not. To link them, select mode to IM_SAME_X_AXIS or IM_SAME_Y_AXIS. To unlink
them select mode equal 0;

int get_oi_plot_axes (O_i *oi);
        Determine how plot and image have their axis linked. Return IM_SAME_X_AXIS or IM_SAME_Y_AXIS or 0.

int is_oi_x_axes_same_as_plot (O_i *oi);
        Simple test to check how plot and image have their X axis linked. Return 1 or 0.

int is_oi_y_axes_same_as_plot (O_i *oi);
        Simple test to check how plot and image have their Y axis linked. Return 1 or 0.



All data may be converted to real physics values by the following macros
     
# define        get_oi_x_user_coordinate(x)     (oi)->ax + (oi)->dx * (x)
# define        get_oi_y_user_coordinate(y)     (oi)->ay + (oi)->dy * (y)
# define        get_oi_z_user_coordinate(z)     (oi)->az + (oi)->dz * (z)


char* get_oi_x_unit_name (O_i *oi);
char* get_oi_y_unit_name (O_i *oi);
char* get_oi_z_unit_name (O_i *oi);
        grab the string defining the units in use for the specific axis.



/*
set_oi_region_of_interest(oi,pixel_user,x0,y0,x1,y1)
get_oi_region_of_interest(oi,pixel_user,*x0,*y0,*x1,*y1)


*/

int set_zmin_zmax_values (O_i *oi, float zmin, float zmax);
        Define the maximum and the minimum of the z scale.

int set_z_black_z_white_values (O_i *oi, float zb, float zw);
        Define the z level associated with back and white.

int get_zmin_zmax_values (O_i *oi, float *zmin, float *zmax);
        Get the maximum and the minimum of the z scale.

int get_z_black_z_white_values (O_i *oi, float *zb, float *zw);
        Ge t the z level associated with back and white.

int find_zmin_zmax(O_i *oi);
        Find automatically the values of zmin and zmax.

O_p* create_and_attach_op_to_oi (O_i *oi,int nx,int ny,int type, int axis_type);
        This functionn create a plot having one data set with nx and ny points, and attach it to an image. 
So far the type is not used, the axis_type allow to link the plot axis to that of the image it may 
be set to IM_SAME_X_AXIS or IM_SAME_Y_AXIS or 0. Returns the pointer to the plot structure on sucess or
Null on error.

d_s* create_and_attach_ds_to_oi (O_i *oi,int nx,int ny,int type);
        This functionn create a data set having nx and ny points, and attach it to the current 
plot attached to the image oi. So far the type is not used, the axis_type allow to link the 
plot axis to that of the image it may be set to IM_SAME_X_AXIS 
or IM_SAME_Y_AXIS or 0. Returns the pointer to the data set structure on sucess or
Null on error or if not plot is associated to the image oi.

O_p* find_oi_cur_op (O_i *oi);
        Return the pointer to the current plot structure associated with oi on sucess or Null otherwise.

        
p_l* create_and_attach_label_to_oi (O_i *oi, float x, float y, int type, const char *format, ...);
        This function creates a label and attaches it to the image oi at a position defined by x, y 
in pixel unit. The label is define using the printf format, the label structure and text string are
allocated automatically. Type may be one of these ABS_COORD, USR_COORD, VERT_LABEL_USR, VERT_LABEL_ABS,
, WHITE_LABEL, OVER_WHITE;


     
        p_l *pl;
        pl = create_and_attach_label_to_oi (oi, 100, 200, USR_COORD, "Image %d",i);
      


un_s* create_and_attach_unit_set_to_oi (O_i *oi, int type, float ax, float dx, char decade, char mode, char *name, int axis);
        Each axis, X, Y, Z, and T may be assigned a unit set which modify the raw unit (pixels, z level
or frame number) by an affine transformation and give it a physical unit (microns, seconds ...). Multiple
unit set be attached at each axis. This function allow to create and attach a new unit set to an axis
of an image oi. axis may be IS_X_UNIT_SET, IS_Y_UNIT_SET, IS_Z_UNIT_SET or IS_T_UNIT_SET;


     
#define create_attach_select_x_un_to_oi(oi, type, ax, dx, decade, mode, name)\
#define create_attach_select_y_un_to_oi(oi, type, ax, dx, decade, mode, name)\
      
        These macros are define as sortcuts.

int push_image_label (O_i *oi, float tx, float ty, char *label, int type);
        This function is deprecate, it attaches a label to an image, better use create_and_attach_label_to_oi

     
# define        remove_cur_op_from_oi(oi)
# define        remove_op_from_oi(oi,op)        
# define        remove_label_from_oi(oi,pl)     
# define        remove_x_unit_set_from_oi(oi,un)
# define        remove_y_unit_set_from_oi(oi,un)
# define        remove_z_unit_set_from_oi(oi,un)
      
        Macros used to remove stuff from the image oi. The data structure are also freed.


int   (image_special_2_use) (O_i *oi);
        This is a pointer to a function that the user may define to perfom customized change of an image.
The "use" is a hook that the user may use to attach its own data structure. The special strings that can
be read from the image file can be use to set the value to the user define structure. If this function
is defined, it will be executed after the image file is read. This function will typically allocate the
user structure and parse the special string to set the structure member to their appropriate value.
 
int   (image_use_2_special) (O_i *oi);
        This is a pointer to a function that the user may define to perfom customized change of an image.
This function if defined will be executed before saving an image to a file. The idea is that this function
will define a series of specials containing the values of the structure.

int (image_free_use) (O_i *oi);
        This is a pointer to a function that the user may define to perfom customized change of an image.
This function will be executed when an image is destroy. If defined, this function is used by the user
to free the data structure attached to the use hook.

int   (image_duplicate_use) (O_i *oid, O_i *ois);
        This is a pointer to a function that the user may define to perfom customized change of an image.
This function will be executed when an image is copied. If defined, this function is used by the user
to duplicate the data structure attached to the use hook.


int save_one_image (O_i *oi, char *file);
        This function save the image to disk using the full filename defined by file.


#define       inherit_from_oi_to_oi          inherit_from_im_to_im
int inherit_from_im_to_im (O_i *dest, O_i *src);
        This function is a housekkeeping one, it is made to be used when you build a new image from
an already existing one, it will transfer the properties of the original to the copied one. 
Thus it will copied the source, the path, the options, the width, the height. It will transfer
the filename and add the treatement of the source image to the history of the destination one. 

#define       inherit_from_oi_to_ds          inherit_from_im_to_ds
int inherit_from_im_to_ds (d_s *dest, O_i *src);
        This function is a housekkeeping one, it is made to be used when you build a plot from
an already existing image, it will transfer the properties of the original image to the dataset. 

int inherit_from_ds_to_ds (d_s *dest, d_s *src);
        This function is a housekkeeping one, it is made to be used when you build a dataset from
an already existing one, it will transfer the properties of the original dataset to the copied one. 




int set_oi_x_unit_set (O_i *oi, int n);
        Select the active unitset to be used for the X axis.

int set_oi_y_unit_set (O_i *oi, int n);
        Select the active unitset to be used for the Y axis.

int set_oi_z_unit_set (O_i *oi, int n);
        Select the active unitset to be used for the Z axis.


int uns_oi_2_op (O_i *ois, int oi_type, O_p *op, int op_type);
        Whenever you construct a plot from an image, you will have transfer the unitset of the
image ois to the plot op. oi_type may be one of IS_X_UNIT_SET, IS_Y_UNIT_SET, IS_Z_UNIT_SET, 
IS_T_UNIT_SET. While op_type may be one of IS_X_UNIT_SET, IS_Y_UNIT_SET.
 
int uns_oi_2_oi (O_i *dest, O_i *src);
        Transfer all unitset from drc image to dest.

int uns_op_2_oi (O_p *op, int op_type, O_i *oid, int oi_type);
        Whenever you construct an image from a plot, you will have transfer the unitset of the
plot op to the image oid. oi_type may be one of IS_X_UNIT_SET, IS_Y_UNIT_SET, IS_Z_UNIT_SET, 
IS_T_UNIT_SET. While op_type may be one of IS_X_UNIT_SET, IS_Y_UNIT_SET.

int uns_oi_2_oi_by_type (O_i *ois, int ois_type, O_i *oid, int oid_type);
        Whenever you construct an image from another image, you will have transfer the unitset of the
fist image ois to the second oid. However your second image may have only one axis in common with the
first one, this function allow just to do that. ois_type and oid_type may be one of IS_X_UNIT_SET, 
IS_Y_UNIT_SET, IS_Z_UNIT_SET, IS_T_UNIT_SET. 

int affine_transform_all_image_unitset (O_i *oi, int type, float offset, float multiplier);
        This function allows to modify all the unitset of one axis at a time.


int swap_image (O_i *oi);


int find_op_nb_of_source_specific_ds_in_oi (O_i *oi, char *source);
        This function is used to retrieve a plot having a specific source in an image. The return
value is the plot number on sucess or -1 otherwise. 

int find_op_nb_of_treatement_specific_ds_in_oi (O_i *oi, char *treatement);
        This function is used to retrieve a plot having a specific treatement in an image. The return
value is the plot number on sucess or -1 otherwise. 



imreg* build_image_region(int x0, int y0, int width, int height, int type);
        This function creates an image region that will be used to display image data. It creates
this structure with one image which memory space for real data has not yet been allocated.

imreg* build_an_empty_image_region(int x0, int y0, int width, int height);
        This function creates an image region that will be used to display image data. It creates
this structure without any image.

int free_image_region (imreg* imr);
        Destroy and free the image region as well as all its elemnents in particular all the
images attached to it.

O_i* create_and_attach_oi_to_imr(imreg *imr, int nx, int ny, int type);
        Create and attach a new image data structure to an existing image region. It returns
the pointer to the O_i on success otherwise NULL.

int alloc_image(imreg *imr, int nx, int ny, int type));
        This functions allocate or reallocate the image data memory necessary to hold an image.

imreg* create_imreg_with_movie(int nx, int ny, int data_type, int n_frames);
        This function creates an image region that will be used to display image data. It creates
this structure with one move which memory space has been allocated.
        
O_i*  create_and_attach_movie_to_imr(imreg *imr, int nx, int ny, int type, int nf);
        Create and attach a new movie data structure to an existing image region. It returns
the pointer to the O_i on success otherwise NULL.

int select_image_of_imreg(imreg *imr, int n);
        Switch the current image of an image region to that having number n;

int select_image_of_imreg_and_display(imreg *imr, int n);
        Switch the current image of an image region to that having number n and display that image
on screen.

int add_image(imreg *imr, int type, void *stuff);
int add_to_image(imreg *imr, int type, void *stuff);
int remove_image(imreg *imr, int type, void *stuff);
int remove_from_image(imreg *imr, int type, void *stuff);

#define find_im_cur_oi(imr)  (imr)->one_i 
        Grab the current image pointer.

O_p* find_im_cur_op(imreg *imr);
        Grab the plot associated to the current image. Returns the pointer to O_P on sucess or
Null otherwise

int x_imdata_2_imr(imreg *imr, int x);
int y_imdata_2_imr(imreg *imr, int y);
float x_imr_2_imdata(imreg *imr, int x);
float y_imr_2_imdata(imreg *imr, int y);

float x_imr_2_im_user_data(imreg *imr, int x);
float y_imr_2_im_user_data(imreg *imr, int y);

int x_pltdata_2_imr(imreg *imr, float x);
int y_pltdata_2_imr(imreg *imr, float y);
float x_imr_2_pltdata(imreg *imr, int yvp);
float y_imr_2_pltdata(imreg *imr, int xvp);

int set_im_x_unit_set(imreg *imr, int n);
int set_im_y_unit_set(imreg *imr, int n);
int set_im_z_unit_set(imreg *imr, int n);

int do_one_image(imreg *imr);

int draw_box_im(int dx, int dy, int scale, int color);
int erase_imr_box(imreg *imr);
int draw_box_imr_plot(imreg *imr, int color);

int refresh_im_plot(imreg *imr, int n_plot);
int refresh_image(imreg *imr, int n_im);

imreg* find_imr_in_current_dialog(DIALOG *di);


int load_im_file_in_imreg (imreg *imr, char *file, char *path);
int imreadfile (O_i *oi, char *file_name);


int set_image_starting_time(O_i *oi);
        synchronize the time field of the image structure with the actual time and initiate
the micro-second counter to measure the duration of a data acquisition.

int set_image_ending_time(O_i *oi);
        ends the micro-second counter to measure the duration of a data acquisition.

int switch_frame_of_disk_movie (O_i *oi, int f);
        loads from disk the specified image as the current frame in a movie (filename and path
must be defined to a valid file!)

int find_CTRL_Z_offset (O_i *oi, FILE *fp);
        internal function needed to grab the file header size which corresponds to the
offset to the first frame of the movie on disk.
 
int save_image_header (O_i* oi, char *head, int size);
        This function is used to save the header part of the file associated to a movie. You do
not need to know the exact number of frames going to be recorded, this parameter may be 
overwritten at the end of acquisition by using close_movie_on_disk.
 
int close_movie_on_disk(O_i *oi, int nf);
        This function is used to overwritte the file header at the end of acquisition 
it allows to specify the actual number of frames recorded and to record the acquisition
duration.

====================================
============ Conclusion ============
====================================

All good things must come to an end. Writing documentation is not a good 
thing, though, and that means it goes on for ever. There is always something 
I've forgotten to explain, or some essential detail I've left out, but for 
now you will have to make do with this. Feel free to ask if you can't figure 
something out.

Enjoy. I hope you find some of this stuff useful.


By Shawn Hargreaves.

http://alleg.sourceforge.net/




